VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00008000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Shoves Ver. 1.10 (Programmed by Lukman H.)"
   ClientHeight    =   8250
   ClientLeft      =   45
   ClientTop       =   735
   ClientWidth     =   11250
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   550
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   750
   StartUpPosition =   2  'CenterScreen
   Begin VB.Label take_lbl 
      Alignment       =   2  'Center
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "COM 2 Takes All Cards"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FFFF&
      Height          =   375
      Left            =   3240
      TabIndex        =   0
      Top             =   3840
      Visible         =   0   'False
      Width           =   4695
   End
   Begin VB.Menu Gm_mnu 
      Caption         =   "&Game"
      Begin VB.Menu gm_submnu 
         Caption         =   "&Deal"
         Index           =   0
      End
      Begin VB.Menu gm_submnu 
         Caption         =   "&Show Rank"
         Index           =   1
      End
      Begin VB.Menu gm_submnu 
         Caption         =   "&Reset Record"
         Index           =   2
      End
      Begin VB.Menu gm_submnu 
         Caption         =   "-"
         Index           =   3
      End
      Begin VB.Menu gm_submnu 
         Caption         =   "&Exit"
         Index           =   4
      End
   End
   Begin VB.Menu tbl_mnu 
      Caption         =   "&Table"
      Begin VB.Menu tbl_submnu 
         Caption         =   "Default"
         Checked         =   -1  'True
         Index           =   0
      End
      Begin VB.Menu tbl_submnu 
         Caption         =   "Blue Sky & Sea"
         Index           =   1
      End
   End
   Begin VB.Menu Help_mnu 
      Caption         =   "&Help"
      Begin VB.Menu Help_submnu 
         Caption         =   "How to Play"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const NONE = -1
Const HUMAN = 0
Const MAXPLAYER = 4
Const CARD_XOF = 15, CARD_YOF = 15
Const FORM_WIDTH = 750, FORM_HEIGHT = 550
Const THROW = 0, TAKE = 1

Private Type data_properties
 name As String * 25
 winning(MAXPLAYER) As Integer
End Type

Private Type Player_Properties
 card(MAXCARD - 1) As Integer
 midX As Integer
 midY As Integer
 ThrownX As Integer
 ThrownY As Integer
 Card_Thrown As Integer
 Win As Boolean
 Score As Integer
End Type

Dim Deck(MAXCARD - 1) As Integer
Dim Player(MAXPLAYER - 1) As Player_Properties
Dim Human_Data As data_properties
Dim Card_Width As Long, Card_Height As Long
Dim Current_Card_Deck As Integer
Dim Animation_Wait As Boolean
Dim Active_Suit As Integer
Dim Open_Deck As Integer
Dim Xpos As Integer, Ypos As Integer
Dim Turn As Integer, Human_Weakness As Integer, winner As Integer
Dim game_over As Boolean
Dim data_filename As String
Function Get_Suit(card_number As Integer) As Integer
Get_Suit = Int(card_number / 13) '*** one suit consists 13 cards
End Function
Function Get_Card_Value(card_number As Integer) As Integer
Get_Card_Value = (card_number Mod 13) + 1
End Function
Function Card_Empty_Slot(cur_player As Integer)
Dim slot As Integer, has_found As Boolean
slot = -1
has_found = False
Do
slot = slot + 1
If Player(cur_player).card(slot) = NONE Then has_found = True
Loop Until has_found = True

Card_Empty_Slot = slot

End Function
Function Order_Card(card_number As Integer)
Dim suit As Integer, number As Integer
'*** Cards.dll put the card order in format A,A,A,A,1,1,1,1,2,2,2,2,...
'*** So we have to convert our format when displaying the card using this DLL
suit = Get_Suit(card_number)
number = Get_Card_Value(card_number)

Order_Card = (number - 1) * 4 + suit '*** we have 4 suit

End Function
Function has_suit(cur_player As Integer, target_suit As Integer) As Boolean
Dim card_num As Integer, i As Integer, flag As Boolean

flag = False

card_num = Card_Empty_Slot(cur_player)
For i = 0 To card_num - 1
 If Get_Suit(Player(cur_player).card(i)) = target_suit Then
    flag = True
    Exit For
 End If
Next i
 
has_suit = flag

End Function
Function Get_Smallest_Card(cur_player As Integer, suit As Integer) As Integer
Dim card_num As Integer, i As Integer
Dim smallest_value As Integer, cur_value As Integer, smallest_index As Integer

smallest_value = 100 '*** let's say that we don't have the smallest one
smallest_index = NONE
card_num = Card_Empty_Slot(cur_player)
With Player(cur_player)
For i = 0 To card_num - 1
 If Get_Suit(.card(i)) = suit Then
    cur_value = Get_Card_Value(.card(i))
    If cur_value = 1 Then cur_value = 14 '*** set ace as the highest
    If cur_value < smallest_value Then smallest_value = cur_value: smallest_index = i
 End If
Next i

Get_Smallest_Card = smallest_index
 
End With
End Function
Sub save_file(filename As String)

Open filename For Random As #1 Len = Len(Human_Data)
 Put #1, , Human_Data
Close #1

End Sub
Sub open_file(filename As String)

Open filename For Random As #1 Len = Len(Human_Data)
 Get #1, , Human_Data
Close #1

End Sub
Sub Finalize_Round()
Dim i As Integer, finish As Boolean
Dim highest_player As Integer
Dim highest_value As Integer, card_value As Integer
 
finish = True
For i = 0 To MAXPLAYER - 1
 If Player(i).Win = False Then
   If Player(i).Card_Thrown = NONE Then finish = False
 End If
Next i

If finish = False Then
   Turn = Turn + 1
Else
   Call Sleep(2000)
   highest_player = NONE
   highest_value = NONE
   For i = 0 To MAXPLAYER - 1
    If Player(i).Win = False Then
       card_value = Get_Card_Value(Player(i).Card_Thrown)
       If card_value = 1 Then card_value = 14
       If card_value > highest_value Then
          highest_player = i
          highest_value = card_value
       End If
     End If
    Next i
    For i = 0 To MAXPLAYER - 1
     Player(i).Card_Thrown = NONE
    Next i
    Active_Suit = NONE
    Open_Deck = NONE
    Call Draw_Card
   Turn = highest_player
End If

End Sub
Sub Shuffle_Deck()
Dim i As Integer, temp_deck As Integer, has_found As Boolean

For i = 0 To MAXCARD - 1
 Deck(i) = NONE
Next i

For i = 0 To MAXCARD - 1
 has_found = False
 Do
  Randomize Timer
  temp_deck = Int(Rnd * MAXCARD)
  If Deck(temp_deck) = NONE Then
     Deck(temp_deck) = i
     has_found = True
  End If
 Loop Until has_found = True
Next i

End Sub
Sub Draw_Card()
Dim card_num As Integer, left_pos As Integer, top_pos As Integer
Dim i As Integer, j As Integer

Form1.Cls

If Animation_Wait = True Then cdtDraw Form1.hdc, Xpos, Ypos, BACKSIDE, 1, vbWhite

If Open_Deck <> NONE Then
 cdtDraw Form1.hdc, (FORM_WIDTH - Card_Width) / 2, (FORM_HEIGHT - Card_Height) / 2, _
         Order_Card(Open_Deck), 0, vbWhite
Else
 If Current_Card_Deck < MAXCARD Then
   cdtDraw Form1.hdc, (FORM_WIDTH - Card_Width) / 2, (FORM_HEIGHT - Card_Height) / 2, _
         BACKSIDE, 1, vbWhite
 End If
End If

For i = 0 To MAXPLAYER - 1
 With Player(i)
 
 Select Case i
  Case 0, 2
   card_num = Card_Empty_Slot(i)
   left_pos = .midX - ((card_num - 1) * CARD_XOF) / 2
   top_pos = .midY - Card_Height / 2
   For j = 0 To card_num - 1
    If i = HUMAN Then
       cdtDraw Form1.hdc, left_pos + (CARD_XOF * j), top_pos, Order_Card(.card(j)), 0, vbWhite
    Else
       cdtDraw Form1.hdc, left_pos + (CARD_XOF * j), top_pos, BACKSIDE, 1, vbWhite
    End If
   Next j
  Case 1, 3
   card_num = Card_Empty_Slot(i)
   left_pos = .midX - Card_Width / 2
   top_pos = .midY - ((card_num - 1) * CARD_YOF) / 2
   For j = 0 To card_num - 1
    cdtDraw Form1.hdc, left_pos, top_pos + (CARD_YOF * j), BACKSIDE, 1, vbWhite
   Next j
 End Select
 
 If .Card_Thrown <> NONE Then
    cdtDraw Form1.hdc, .ThrownX - Card_Width / 2, .ThrownY - Card_Height / 2, Order_Card(.Card_Thrown), 0, vbWhite
 End If
 
 End With
Next i

Form1.Refresh

End Sub
Sub shove(cur_player As Integer, target_suit As Integer)
Dim card_slot As Integer, has_found As Boolean

'*** begin
card_slot = Card_Empty_Slot(cur_player)
has_found = False

Do
 Call Animate_Card(TAKE, cur_player)
 Player(cur_player).card(card_slot) = Deck(Current_Card_Deck)
 If Get_Suit(Player(cur_player).card(card_slot)) = target_suit Then has_found = True
 Current_Card_Deck = Current_Card_Deck + 1
 card_slot = card_slot + 1
 Call Draw_Card
Loop Until (Current_Card_Deck >= MAXCARD) Or has_found = True

If Current_Card_Deck >= MAXCARD And has_found = False Then
   Call Take_Card(cur_player)
End If

End Sub
Sub Animate_Card(direction As Integer, cur_player As Integer)
Dim start_X As Integer, start_Y As Integer, Last_X As Integer, Last_Y As Integer
Dim speed As Integer, has_arrived As Boolean

Animation_Wait = True
speed = 15
has_arrived = False

If direction = THROW Then
   Last_X = Player(cur_player).ThrownX - Card_Width / 2
   Last_Y = Player(cur_player).ThrownY - Card_Height / 2
   start_X = Player(cur_player).midX - Card_Width / 2
   start_Y = Player(cur_player).midY - Card_Height / 2
   Xpos = start_X
   Ypos = start_Y

   Do
    delay (25)
    Call Draw_Card
    Select Case cur_player
      Case 0
       Ypos = Ypos - speed
       If Ypos < Last_Y Then has_arrived = True
      Case 1
       Xpos = Xpos - speed
       If Xpos < Last_X Then has_arrived = True
      Case 2
       Ypos = Ypos + speed
       If Ypos > Last_Y Then has_arrived = True
      Case 3
       Xpos = Xpos + speed
       If Xpos > Last_X Then has_arrived = True
    End Select
   Loop Until has_arrived = True
   
Else
   start_X = FORM_WIDTH / 2 - Card_Width / 2
   start_Y = FORM_HEIGHT / 2 - Card_Height / 2
   Last_X = Player(cur_player).midX - Card_Width / 2
   Last_Y = Player(cur_player).midY - Card_Height / 2
   Xpos = start_X
   Ypos = start_Y

   Do
    delay (25)
    Call Draw_Card
    Select Case cur_player
      Case 0
       Ypos = Ypos + speed
       If Ypos > Last_Y Then has_arrived = True
      Case 1
       Xpos = Xpos + speed
       If Xpos > Last_X Then has_arrived = True
      Case 2
       Ypos = Ypos - speed
       If Ypos < Last_Y Then has_arrived = True
      Case 3
       Xpos = Xpos - speed
       If Xpos < Last_X Then has_arrived = True
    End Select
   Loop Until has_arrived = True
End If

Animation_Wait = False
End Sub
Sub Initialize_Game()
Dim i As Integer, j As Integer

Player(0).midX = FORM_WIDTH / 2
Player(0).midY = FORM_HEIGHT - 50
Player(0).ThrownX = (FORM_WIDTH / 2)
Player(0).ThrownY = (FORM_HEIGHT / 2) + (1 * Card_Height)
Player(1).midX = FORM_WIDTH - 50
Player(1).midY = FORM_HEIGHT / 2
Player(1).ThrownX = (FORM_WIDTH / 2) + (1 * Card_Width) + 2
Player(1).ThrownY = (FORM_HEIGHT / 2)
Player(2).midX = FORM_WIDTH / 2
Player(2).midY = 50
Player(2).ThrownX = (FORM_WIDTH / 2)
Player(2).ThrownY = (FORM_HEIGHT / 2) - (1 * Card_Height)
Player(3).midX = 50
Player(3).midY = FORM_HEIGHT / 2
Player(3).ThrownX = (FORM_WIDTH / 2) - (1 * Card_Width)
Player(3).ThrownY = (FORM_HEIGHT / 2)

For i = 0 To MAXPLAYER - 1
 Player(i).Card_Thrown = NONE
 Player(i).Win = False
 For j = 0 To MAXCARD - 1
  Player(i).card(j) = NONE
 Next j
Next i

Current_Card_Deck = 0
Human_Weakness = NONE
game_over = False
winner = 0

'*** give 5 cards for all players
For i = 1 To 5
 For j = 0 To MAXPLAYER - 1
  Player(j).card(Card_Empty_Slot(j)) = Deck(Current_Card_Deck)
  Current_Card_Deck = Current_Card_Deck + 1
 Next j
Next i
Call Sort_Card(HUMAN)

Open_Deck = Deck(Current_Card_Deck)
Current_Card_Deck = Current_Card_Deck + 1
Active_Suit = Get_Suit(Open_Deck)

Call Draw_Card

'*** player 0 always take the first step
Turn = MAXPLAYER
Call next_turn

End Sub

Sub reset_record()
Dim i As Integer

With Human_Data
 .name = InputBox("Input Player Name:")
If .name = "" Then .name = "No Name"
If Len(.name) > 25 Then .name = Left(.name, 25)

For i = 1 To MAXPLAYER
    .winning(i) = 0
Next i
Call save_file(data_filename)

End With

End Sub
Private Sub Form_Load()

cdtInit Card_Width, Card_Height
game_over = True

data_filename = App.Path & "\data.dat"

If File_Exists(data_filename) = False Then
   Call reset_record
Else
   Call open_file(data_filename)
End If

Call tbl_submnu_Click(1)

End Sub
Sub Sort_Card(cur_player As Integer)
Dim card_num As Integer, temp_value As Integer
Dim i As Integer, j As Integer

card_num = Card_Empty_Slot(cur_player)
If card_num < 2 Then Exit Sub

With Player(cur_player)
For i = 0 To card_num - 2
 For j = i + 1 To card_num - 1
  If .card(i) > .card(j) Then
     temp_value = .card(i)
     .card(i) = .card(j)
     .card(j) = temp_value
  End If
 Next j
Next i
End With

End Sub
Sub Rearrange_Card(cur_player As Integer)
Dim i As Integer, card_slot As Integer, finish As Boolean

finish = False
With Player(cur_player)
Do
card_slot = Card_Empty_Slot(cur_player)
If .card(card_slot + 1) = NONE Then
   finish = True
Else
   .card(card_slot) = .card(card_slot + 1)
   .card(card_slot + 1) = NONE
End If
Loop Until finish = True
End With

Call Sort_Card(cur_player)

End Sub
Sub Throw_Card(cur_player As Integer, card_number As Integer)
Dim thrown_card As Integer

With Player(cur_player)
      If Active_Suit = NONE Then Active_Suit = Get_Suit(.card(card_number))
      thrown_card = .card(card_number)
      .card(card_number) = NONE
      Call Rearrange_Card(cur_player)
      Call Animate_Card(THROW, cur_player)
      .Card_Thrown = thrown_card
      If Card_Empty_Slot(cur_player) = 0 Then
         Player(cur_player).Win = True
         winner = winner + 1
         If winner = 3 Then
            game_over = True
            If cur_player <> HUMAN And Player(HUMAN).Win = False Then _
               Human_Data.winning(4) = Human_Data.winning(4) + 1
         End If
         If cur_player = HUMAN Then
            Dim ask As Long
            ask = MsgBox("You win! Would you like to watch the game continue?", _
                vbYesNo + vbInformation, "Win")
            If ask = vbNo Then game_over = True
            Human_Data.winning(winner) = Human_Data.winning(winner) + 1
         End If
      End If
      Call Draw_Card
End With
End Sub

Sub Computer_Turn(current_turn As Integer)
Dim card_num As Integer, i As Integer
Dim temp_card(MAXCARD - 1) As Integer, temp_card_counter As Integer

If Player(current_turn).Win = True Then Turn = Turn + 1: Exit Sub

card_num = Card_Empty_Slot(current_turn)

With Player(current_turn)

If Active_Suit <> NONE Then
  
  temp_card_counter = 0
  For i = 0 To card_num - 1
   If Get_Suit(.card(i)) = Active_Suit Then
      temp_card(temp_card_counter) = i
      temp_card_counter = temp_card_counter + 1
   End If
  Next i
  If temp_card_counter = 0 Then '*** means no matching suit available
     If Current_Card_Deck < MAXCARD Then
        Call shove(current_turn, Active_Suit)
        card_num = Card_Empty_Slot(current_turn)
        Call Throw_Card(current_turn, card_num - 1) '*** throw the last one
        Call Finalize_Round
     Else '*** Taking card procedure
        Call Take_Card(current_turn)
     End If
  Else '*** if it has the suit, then choose random and throw
     Call Throw_Card(current_turn, temp_card(Int(Rnd * temp_card_counter)))
     Call Finalize_Round
  End If

Else '*** this computer is the starter
     '*** rather than random, why don't make things difficult for human?
     If Human_Weakness <> NONE Then
      If has_suit(current_turn, Human_Weakness) = True Then
         Call Throw_Card(current_turn, Get_Smallest_Card(current_turn, Human_Weakness))
      Else
         Call Throw_Card(current_turn, Int(Rnd * card_num))
      End If
     Else
      Call Throw_Card(current_turn, Int(Rnd * card_num))
     End If
    Call Finalize_Round

End If

End With

End Sub
Sub Take_Card(cur_player As Integer)
Dim highest_player As Integer, highest_value As Integer, card_value As Integer
Dim card_slot As Integer, i As Integer
Dim msg As String

If cur_player = HUMAN Then
   msg = "Player takes all card"
Else
   msg = "COM " & Trim(Str(cur_player)) & " takes all card"
End If

take_lbl.Caption = msg

take_lbl.Visible = True
take_lbl.Refresh
Call Sleep(2000)
take_lbl.Visible = False

highest_player = cur_player
highest_value = NONE
   For i = 0 To MAXPLAYER - 1
    If Player(i).Card_Thrown <> NONE Then
       card_slot = Card_Empty_Slot(cur_player)
       Player(cur_player).card(card_slot) = Player(i).Card_Thrown
       If Player(i).Win = False Then
          card_value = Get_Card_Value(Player(i).Card_Thrown)
          If card_value = 1 Then card_value = 14
          If card_value > highest_value Then
             highest_player = i
             highest_value = card_value
          End If
       End If
       Player(i).Card_Thrown = NONE
     End If
   Next i

Active_Suit = NONE
Open_Deck = NONE
Call Draw_Card
Turn = highest_player
   
End Sub
Sub show_human_stat()
Dim i As Integer, temp_str As String

  temp_str = "PLAYER STATISTIC" + vbCrLf + Human_Data.name + vbCrLf + vbCrLf
  For i = 1 To MAXPLAYER - 1
   temp_str = temp_str + "Rank " + Trim(Str(i)) + ": " + Trim(Str(Human_Data.winning(i))) + " times" + vbCrLf
  Next i
  temp_str = temp_str + "Lose: " + Trim(Str(Human_Data.winning(4))) + " times"
  MsgBox temp_str, vbInformation, "Winning Stroke"
End Sub
Sub next_turn()

If game_over = True Then GoTo exit_point

Do
If Turn > MAXPLAYER - 1 Or Turn = HUMAN Then
   Turn = HUMAN
   If Player(HUMAN).Win = False Then
    If Active_Suit <> NONE Then
     If has_suit(HUMAN, Active_Suit) = False Then
      If Current_Card_Deck < MAXCARD Then
        Human_Weakness = Active_Suit
        Call shove(HUMAN, Active_Suit)
      Else '***taking procedure
       Human_Weakness = Active_Suit
       Call Take_Card(HUMAN)
      End If
     End If
    End If
   Else
    Turn = Turn + 1
   End If
Else
   If Player(Turn).Win = True Then
      Turn = Turn + 1
   Else
    If Turn <> HUMAN Then
      Call Computer_Turn(Turn)
    End If
   End If
End If
Loop Until Turn = HUMAN Or game_over = True

exit_point:
If game_over = True Then
   Call save_file(data_filename)
   Call show_human_stat
End If

End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim left_pos As Integer, top_pos As Integer, right_pos As Integer, bottom_pos As Integer
Dim card_num As Integer, select_card As Integer

If Animation_Wait = True Or Turn <> HUMAN Or game_over = True Then Exit Sub

With Player(HUMAN)
card_num = Card_Empty_Slot(HUMAN)
left_pos = .midX - ((card_num - 1) * CARD_XOF) / 2
top_pos = .midY - Card_Height / 2

right_pos = left_pos + ((card_num - 1) * CARD_XOF) + Card_Width
bottom_pos = top_pos + Card_Height

If (Y >= top_pos And Y <= bottom_pos) And (X >= left_pos And X <= right_pos) Then
   select_card = Int((X - left_pos) / CARD_XOF)
   If select_card > card_num - 1 Then select_card = card_num - 1
   If Active_Suit = NONE Then
      Call Throw_Card(HUMAN, select_card)
      Call Finalize_Round
      Call next_turn
   Else
    If Get_Suit(.card(select_card)) = Active_Suit Then
      Call Throw_Card(HUMAN, select_card)
      Call Finalize_Round
      Call next_turn
    Else
      '*** player click the unsuitable suit, nothing to do
    End If
   End If
End If

End With

End Sub

Private Sub Form_Unload(Cancel As Integer)
End
End Sub

Private Sub gm_submnu_Click(Index As Integer)
Dim ask As Long

If Index <> 4 And Animation_Wait = True Then Exit Sub
Select Case Index
 Case 0
  Call Shuffle_Deck
  Call Initialize_Game
 Case 1
  Call show_human_stat
 Case 2
  ask = MsgBox("This will reset previous name and record. Continue?", vbInformation + vbYesNo, "Confirm Reset")
  If ask = vbYes Then Call reset_record
 Case 4
  End
End Select
End Sub

Private Sub Help_submnu_Click()
Form2.Show vbModal
End Sub

Private Sub tbl_submnu_Click(Index As Integer)
Dim i As Integer, filename As String

If tbl_submnu(Index).Checked = True Then Exit Sub

For i = 0 To 1
 tbl_submnu(i).Checked = False
Next i

Select Case Index
 Case 0
  Form1.Picture = LoadPicture("")
  tbl_submnu(Index).Checked = True
 Case 1
  filename = App.Path & "\table01.jpg"
  If File_Exists(filename) Then
     Form1.Picture = LoadPicture(filename)
     tbl_submnu(Index).Checked = True
  End If
End Select

If game_over = False Then Call Draw_Card

End Sub
